image: gitlab.ub.uni-bielefeld.de:4567/rdtk/citk/build-gen:0.35

test:
  stage: test
  script:
    - /bin/build-generator --version
    - /bin/build-generator --on-error fail --progress-style none validate . 1> >(tee log.out)  
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  artifacts:
    when: on_failure
    paths:
      - log.out

build_image: 
  rules:
    - when: manual
      allow_failure: true
      changes: 
      - tools/Dockerfile
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:v1.9.0-debug
    entrypoint: [""]
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/tools/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}/build-gen:0.35"

post_message_to_mr:
  rules: 
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: on_failure
  stage: deploy
  dependencies:
    - test
  variables:
    TOKEN: $ci_api_token
  script:
    - |
      sed -i '1s/^/### Pipeline failed with the following output:\n\n/' log.out
    - |
      jq -Rs '{body: . }' log.out > error.json
    - 'curl --location --request POST "https://gitlab.ub.uni-bielefeld.de//api/v4/projects/$CI_MERGE_REQUEST_PROJECT_ID/merge_requests/$CI_MERGE_REQUEST_IID/notes" --header "PRIVATE-TOKEN: $TOKEN" --header "Content-Type: application/json" --data-binary "@error.json"'
